/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.fluxml;

import java.io.IOException;
import java.util.Map;

/**
 * MarkupWriter provides an API for XML serialization
 *
 * @author tiwe
 * @version $Id$
 */
public interface MarkupWriter<A extends MarkupWriter<A>> {

    A attribute(String name, String value) throws IOException;

    A attributes(Map<String,String> attributes) throws IOException;

    A begin(String name) throws IOException;
    
    A end(String name) throws IOException;

    A print(String text) throws IOException;

    A printRaw(String text) throws IOException;

}