/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.fluxml;

import java.io.IOException;
import java.io.Writer;

import org.apache.commons.lang.StringEscapeUtils;

/**
 * XMLWriter provides a fluent API for XML/XHTML serialization
 *
 * @author tiwe
 * @version $Id$
 */
public class XMLWriter extends AbstractMarkupWriter<XMLWriter>{

    public XMLWriter(Writer writer) {
        super(writer);
    }

    @Override
    protected void escapeMarkup(Writer writer, String val) throws IOException {
        StringEscapeUtils.escapeXml(writer, val);        
    }

    @Override
    protected void closeEmptyTag(Writer writer) throws IOException {
        writer.write("/>");        
    }

    
}
