/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.fluxml.tree;

import java.io.IOException;

import com.mysema.commons.fluxml.MarkupWriter;


/**
 * DefaultTreeRenderer provides
 *
 * @author tiwe
 * @version $Id$
 */
public class DefaultTreeRenderer<NodeType, Writer extends MarkupWriter<Writer>> extends TreeRenderer<NodeType,Writer>{
    
    private String ul, li, ulClass, liClass;
    
    public DefaultTreeRenderer(){
        this(false, "ul", "li", null, null);
    }
    
    public DefaultTreeRenderer(boolean showRoot, String listEl, String childEl, String ulClass, String liClass){
        this.showRoot = showRoot;
        this.ul = listEl;
        this.li = childEl;
        this.ulClass = ulClass;
        this.liClass = liClass;
    }
    
    protected void beginItem(Writer writer) throws IOException {
        writer.begin(li);
        if (liClass != null) writer.attribute("class", liClass);
    }

    protected void beginList(Writer writer) throws IOException {
        writer.begin(ul);
        if (ulClass != null) writer.attribute("class", ulClass);
    }

    protected void endItem(Writer writer) throws IOException {
        writer.end(li);
    }   
    
    protected void endList(Writer writer) throws IOException {
        writer.end(ul);
    }

    protected void renderItemContent(Writer writer, NodeType node) throws IOException{
        writer.print(node.toString());
    }

    // dependencies

    public void setLi(String li) {
        this.li = li;
    }

    public void setLiClass(String liClass) {
        this.liClass = liClass;
    }

    public void setUl(String ul) {
        this.ul = ul;
    }

    public void setUlClass(String ulClass) {
        this.ulClass = ulClass;
    }
    

}
